package cn.com.infosec.mobile.android.net;

import android.support.annotation.Keep;
import android.support.annotation.NonNull;
import android.text.TextUtils;
import cn.com.infosec.mobile.android.IMSSdk;
import cn.com.infosec.mobile.android.Jointer;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.ProtocolException;
import java.net.SocketPermission;
import java.net.URL;
import java.security.Permission;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.IdentityHashMap;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Set;
import java.util.TimeZone;
import java.util.regex.Pattern;

/** @deprecated */
@Deprecated
@Keep
public class InfosecHttpsURLConnection extends HttpURLConnection implements InfosecSSLOption {
   private static final Set<String> METHODS = new LinkedHashSet(Arrays.asList("GET", "POST"));
   private static final Pattern CRLF = Pattern.compile("\r\n");
   private static final Pattern SEMICOLON = Pattern.compile(";");
   private static final Pattern COLON_SPACE = Pattern.compile(": ");
   private InfosecHttpRequest httpRequest = new InfosecHttpRequest();
   private InfosecHttpParam httpParam;
   private ByteArrayInputStream inputStream;
   private ByteArrayOutputStream outputStream;
   private String responseBody;
   private String responseHeader;

   InfosecHttpsURLConnection(@NonNull URL url) {
      super(url);
      (this.httpParam = new InfosecHttpParam()).setConnectTimeout(30000);
      this.httpParam.setRequestTimeout(30000);
      this.httpParam.setServerURL(url.toString());
   }

   private int getDefaultPort(@NonNull String protocol) {
      return TextUtils.equals("http", protocol) ? 80 : 443;
   }

   public void connect() {
      if (!super.connected) {
         super.connected = true;
      }

   }

   public void disconnect() {
      super.connected = false;
   }

   public InputStream getErrorStream() {
      String var1 = this.httpRequest.getErrNo() + ":" + this.httpRequest.getErrMsg();
      return new ByteArrayInputStream(var1.getBytes());
   }

   public String getHeaderField(int position) {
      return TextUtils.isEmpty(this.responseHeader) ? null : TextUtils.split(this.responseHeader, CRLF)[position];
   }

   public String getHeaderFieldKey(int n) {
      return TextUtils.isEmpty(this.responseHeader) ? null : TextUtils.split(TextUtils.split(this.responseHeader, CRLF)[n], COLON_SPACE)[0];
   }

   public String getHeaderField(@NonNull String name) {
      Map var2;
      if ((var2 = this.getHeaderFields()) != null && var2.size() > 0) {
         List var3;
         if ((var3 = (List)var2.get(name)) != null && var3.size() > 0) {
            List var10000 = var3;
            StringBuilder var4;
            var4 = new StringBuilder.<init>();
            Iterator name1 = var10000.iterator();

            while(name1.hasNext()) {
               var4.append(((String)name1.next()).concat(";"));
            }

            String var6;
            if ((var6 = var4.toString()).endsWith(";")) {
               var6 = var6.substring(0, var6.length() - 2);
            }

            return var6;
         } else {
            return null;
         }
      } else {
         return null;
      }
   }

   public Map<String, List<String>> getHeaderFields() {
      if (TextUtils.isEmpty(this.responseHeader)) {
         return null;
      } else {
         IdentityHashMap var6 = null;
         String[] var1;
         if ((var1 = TextUtils.split(this.responseHeader, CRLF)) != null && var1.length > 0) {
            var6 = new IdentityHashMap.<init>();
            int var2 = var1.length;

            for(int var3 = 0; var3 < var2; ++var3) {
               String var4;
               if (!TextUtils.isEmpty(var4 = var1[var3]) && !var4.startsWith("HTTP/")) {
                  String[] var10001 = TextUtils.split(var4, COLON_SPACE);
                  var4 = var10001[0];
                  String[] var5 = TextUtils.split(var10001[1], SEMICOLON);
                  ArrayList var7;
                  ArrayList var10002 = var7 = new ArrayList;
                  var7.<init>(var5.length);
                  var10002.addAll(Arrays.asList(var5));
                  var6.put(var4, var7);
               }
            }
         }

         return var6;
      }
   }

   public Map<String, List<String>> getRequestProperties() {
      if (super.connected) {
         throw new IllegalStateException("Cannot access request header fields after connection is set");
      } else {
         HashMap var4;
         if ((var4 = this.httpParam.getHeaders()) != null && var4.size() > 0) {
            HashMap var1;
            var1 = new HashMap.<init>(var4.size());
            Iterator var5 = var4.entrySet().iterator();

            while(var5.hasNext()) {
               Map.Entry var2;
               Map.Entry var10001 = var2 = (Map.Entry)var5.next();
               ArrayList var3;
               ArrayList var10002 = var3 = new ArrayList;
               var3.<init>();
               var10002.add(var2.getValue());
               var1.put(var10001.getKey(), var3);
            }

            return var1;
         } else {
            return null;
         }
      }
   }

   public InputStream getInputStream() {
      if (!TextUtils.isEmpty(this.responseBody)) {
         return this.inputStream = new ByteArrayInputStream(this.responseBody.getBytes());
      } else if (!super.doInput) {
         throw new ProtocolException("This protocol does not support input");
      } else {
         ByteArrayOutputStream var1;
         if ((var1 = this.outputStream) != null && var1.size() > 0) {
            this.httpParam.setPostField(this.outputStream.toByteArray());
         }

         this.responseBody = null;
         if ("GET".equalsIgnoreCase(super.method)) {
            this.responseBody = this.httpRequest.get(this.httpParam);
         } else if ("POST".equalsIgnoreCase(super.method)) {
            this.responseBody = this.httpRequest.post(this.httpParam);
         }

         String var2;
         this.responseHeader = var2 = this.httpRequest.getHeader();
         super.responseCode = this.httpRequest.responseCode;
         if (TextUtils.isEmpty(var2) && TextUtils.isEmpty(this.responseBody)) {
            this.disconnect();
         }

         this.connect();
         if (!TextUtils.isEmpty(this.responseBody)) {
            this.inputStream = new ByteArrayInputStream(this.responseBody.getBytes());
         } else {
            this.inputStream = new ByteArrayInputStream(new byte[0]);
         }

         return this.inputStream;
      }
   }

   public OutputStream getOutputStream() {
      ByteArrayOutputStream var1;
      ByteArrayOutputStream var10000 = var1 = new ByteArrayOutputStream;
      var1.<init>();
      this.outputStream = var1;
      return var10000;
   }

   public Permission getPermission() {
      super.getPermission();
      URL var1;
      URL var10000 = var1 = this.getURL();
      String var2 = var10000.getHost();
      int var3;
      if (var10000.getPort() != -1) {
         var3 = var1.getPort();
      } else {
         var3 = this.getDefaultPort(var1.getProtocol());
      }

      return new SocketPermission(var2 + ":" + var3, "connect, resolve");
   }

   public String getRequestProperty(@NonNull String key) {
      if (!super.connected) {
         return (String)this.httpParam.getHeaders().get(key);
      } else {
         throw new IllegalStateException("Cannot access request header fields after connection is set");
      }
   }

   public void setRequestProperty(@NonNull String key, @NonNull String value) {
      if (!super.connected) {
         this.httpParam.addHeader(key, value);
      } else {
         throw new IllegalStateException("Cannot add request property after connection is made");
      }
   }

   public void addRequestProperty(@NonNull String key, @NonNull String value) {
      this.setRequestProperty(key, value);
   }

   public void setConnectTimeout(int timeout) {
      this.httpParam.setConnectTimeout(timeout);
   }

   public int getConnectTimeout() {
      return this.httpParam.getConnectTimeout();
   }

   public void setReadTimeout(int timeout) {
      this.httpParam.setRequestTimeout(timeout);
   }

   public int getReadTimeout() {
      return this.httpParam.getRequestTimeout();
   }

   public void setVerifyHost(int verifyHost) {
      this.httpParam.setVerifyHost(verifyHost);
   }

   public void setIpHost(String ip, String host) {
      this.httpRequest.setIpHost(ip, host);
   }

   public void setEnableVerifyHostCallback(int enableVerifyHostCallback) {
      this.httpRequest.setEnableVerifyHostCallback(enableVerifyHostCallback);
   }

   public boolean usingProxy() {
      return false;
   }

   public void setIfModifiedSince(long ifmodifiedsince) {
      super.setIfModifiedSince(ifmodifiedsince);
      if (super.ifModifiedSince != 0L) {
         SimpleDateFormat ifmodifiedsince1;
         SimpleDateFormat var10001 = ifmodifiedsince1 = new SimpleDateFormat;
         var10001.<init>("EEE, dd MMM yyyy HH:mm:ss 'GMT'", Locale.CHINA);
         var10001.setLenient(false);
         var10001.setTimeZone(TimeZone.getTimeZone("GMT"));
         this.httpParam.addHeader("If-Modified-Since", ifmodifiedsince1.format(new Date(super.ifModifiedSince)));
      } else {
         this.httpParam.getHeaders().remove("If-Modified-Since");
      }

   }

   public void setRequestMethod(@NonNull String method) {
      Set var2;
      if ((var2 = METHODS).contains(method)) {
         super.method = method;
      } else {
         throw new ProtocolException("Expected one of " + var2 + " but was " + method);
      }
   }

   public void setTrustCert(@NonNull String trustCert) {
      if (!super.connected) {
         this.httpParam.setCaFile(trustCert);
      } else {
         throw new IllegalStateException("Cannot set trustCert after connection is made");
      }
   }

   public String getTrustCert() {
      return this.httpParam.getCaFile();
   }

   public void setClientCert(@NonNull String signCert, @NonNull String signKey, String encCert, String encKey, String keyPass) {
      if (!super.connected) {
         if (!TextUtils.isEmpty(signCert) && !TextUtils.isEmpty(signKey)) {
            this.httpParam.setSignCert(signCert);
            this.httpParam.setSignKey(signKey);
            this.httpParam.setEncCert(encCert);
            this.httpParam.setEncKey(encKey);
            this.httpParam.setSslPasswd(keyPass);
         } else {
            throw new IllegalArgumentException("signCert is empty");
         }
      } else {
         throw new IllegalStateException("Cannot set trustCert after connection is made");
      }
   }

   public void setClientCert(@NonNull String certAlias, @NonNull String certPIN) {
      if (!super.connected) {
         if (!TextUtils.isEmpty(certAlias) && !TextUtils.isEmpty(certPIN)) {
            if (IMSSdk.isCollaborative()) {
               Jointer var3;
               Jointer var10001 = var3 = new Jointer;
               var3.<init>();
               var10001.setUser(certAlias);
               this.httpParam.setJointer(var3);
            }

            this.httpParam.setCertAlias(certAlias);
            this.httpParam.setCertPIN(certPIN);
         } else {
            throw new IllegalArgumentException("certAlias or certPIN is empty");
         }
      } else {
         throw new IllegalStateException("Cannot set trustCert after connection is made");
      }
   }
}
